C-----F--1---------2---------3---------4---------5---------6
C
      FUNCTION DROT(L,MP,M,BETA)
C   RETURNS THE PART OF THE D COEFFICIENT RELATED TO THE
C   BETA EULER ANGLE. THE EQUATION (4.13) OF M.E.ROSE (1957,
C   "ELEMENTARY THEORY OF ANGULAR MOMENTUM", WILEY, NEW
C   YORK) IS USED.
C   WRITTEN 11-10-85 DLF.
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION NINC(50),RATC(50),RATS(50)
      DIMENSION FI(99),SQ(99)
      DIMENSION AM(4),MF(4),NF(4)
      SAVE NSET,FI,SQ
      DATA NSET/0/,LL/99/
      EQUIVALENCE (M1,MF(1)),(M2,MF(2)),(M3,MF(3)),
     & (M4,MF(4))
      EQUIVALENCE (N1,NF(1)),(N2,NF(2)),(N3,NF(3)),
     & (N4,NF(4))
C
      IF(NSET.EQ.1)GOTO 20
      DO 10 I=1,LL
      FI(I)=DFLOAT(I)
   10 SQ(I)=DSQRT(FI(I))
      NSET=1
   20 IF(L.EQ.0)GOTO 180
      BETA2=0.5D0*BETA
      COSB=DCOS(BETA2)
      SINB=-DSIN(BETA2)
      C2=COSB**2
      S2=1.0D0-C2
      N1=L+M
      N2=L-M
      N3=L+MP
      N4=L-MP
      MPMM=MP-M
      KMAX=MIN0(N4,N1)
      KMIN=MAX0(0,-MPMM)
      NKM1=KMAX-KMIN
      NK=NKM1+1
      KMINM1=KMIN-1
      IF(NKM1.EQ.0)GOTO 80
      DO 60 I=1,NKM1
      K=I+KMINM1
      KP1=K+1
      RATC(I)=C2*(MPMM+KP1)*KP1
      RATS(I)=S2*(N4-K)*(N1-K)
      IF(RATS(I)-RATC(I))30,40,50
   30 NINC(I)=-1
      GOTO 60
   40 NINC(I)=0
      GOTO 60
   50 NINC(I)=1
   60 CONTINUE
      DO 70 I=1,NKM1
      IF(NINC(I).LT.1)GOTO 90
   70 CONTINUE
   80 I=NK
   90 KTOP=I+KMINM1
      M1=N4-KTOP
      M2=N1-KTOP
      M3=KTOP+MPMM
      M4=KTOP
      AM(1)=COSB
      AM(2)=COSB
      AM(3)=SINB
      AM(4)=SINB
      TERM=1.0D0
      IF(MOD(KTOP,2).NE.0)TERM=-1.0D0
      LD=2*L
      NA=1
      KA=0
      NB=3
      KB=0
      NC=1
      KC=0
      KL=0
  100 KL=KL+1
  110 KA=KA+1
      IF(KA.LE.NF(NA))GOTO 120
      NA=NA+1
      KA=0
      GOTO 110
  120 KB=KB+1
      IF(KB.LE.NF(NB))GOTO 130
      NB=NB+1
      KB=0
      GOTO 120
  130 KC=KC+1
      IF(KC.LE.MF(NC))GOTO 140
      NC=NC+1
      KC=0
      GOTO 130
  140 TERM=TERM*((SQ(KA)*SQ(KB)*AM(NC))/FI(KC))
      IF(KL.LT.LD)GOTO 100
      DROT=TERM
      K0=KTOP-KMINM1
      IF(KTOP.EQ.KMAX)GOTO 160
      UP=TERM
      K=K0
  150 J=K
      K=K+1
      UP=-UP*(RATS(J)/RATC(J))
      DROT=DROT+UP
      IF(K.LT.NK)GOTO 150
  160 IF(KTOP.EQ.KMIN)RETURN
      DOWN=TERM
      K=K0
  170 K=K-1
      DOWN=-DOWN*(RATC(K)/RATS(K))
      DROT=DROT+DOWN
      IF(K.GT.1)GOTO 170
      RETURN
  180 DROT=1.0D0
      RETURN
      END
