#include<math.h>

#define Max(a,b) ( ( (a)>(b)  )? (a):(b))
#define Min(a,b) ( ( (a)>(b)  )? (a):(b))

static double CComb(int n, int m, double a, double b) {
  double esp=0;
  int nsegni=0;
  int segno;
  int i;

  for (i=m+1; i<=n; i++) {
    esp+=log(1.0*i);
  }
  for (i=1; i<=n-m; i++) {
    esp-=log(1.0*i);
  }
  
  if(m) {
    if(a!=0) {
      esp+=m*log(fabs(a));
    } else {
      return 0.0;
    }
    if(a<0) nsegni+=m;
  }
  
  if(n-m) {
    if(b!=0) {
      esp+=(n-m)*log(fabs(b));
    } else {
      return 0.0;
    }
    if(b<0) nsegni+=n-m;
  } 
  segno=(((nsegni%2)==0)? 1:-1  );
  return exp(esp)*segno;
}


double drotam(int l, int mp, int m, double theta) ;

/* per il fortran */
double drotam_(int *l, int * mp, int *m, double *theta) {
  return drotam(*l,  * mp,  *m,  *theta);
}


double drotam(int l, int mp, int m, double theta) {
  int aspinsUP=l+m;
  int bspinsUP=l+mp ;
  int nmezzi=2*l;
  double ct=cos(theta/2);
  double st=sin(theta/2);
  double res=0.0;
  int uu;
  int k;
  for(  uu =Max(0, bspinsUP - (nmezzi-aspinsUP)  ) ; uu<= bspinsUP && uu
<=aspinsUP; uu++) {
    res+=CComb(aspinsUP, uu, ct ,st  )*CComb(nmezzi-aspinsUP, bspinsUP
-uu, -st, ct  );
  }
  
  if(aspinsUP<bspinsUP) {
    for( k=aspinsUP+1; k<=bspinsUP;k++) {
      res=res*sqrt(k+0.0);
      res=res/sqrt(nmezzi-k+1.);
    }
  } else {
    for( k=bspinsUP+1; k<=aspinsUP;k++) {
      res=res/sqrt(k+0.);
      res=res*sqrt(nmezzi-k+1.);
    }
  }
  return res;
}
